/*****************************************************

This program was produced by the

CodeWizardAVR V2.03.4 Standard

Automatic Program Generator

 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.

http://www.hpinfotech.com



Project : WindSpeedMeter

Version : 

Date    : 2015-10-22

Author  : MS

Company : No Company

Comments: 





Chip type           : ATmega8L

Program type        : Application

Clock frequency     : 4,000000 MHz

Memory model        : Small

External RAM size   : 0

Data Stack size     : 256

*****************************************************/



#include <mega8.h>

#include <delay.h>

#include <my_spi.h>

#include <SSD1306.h>

#include <string.h>

#include <bitmaps.h>





//#define ADC_CONFIG (1<<REFS0) //AVCC pin

#define ADC_CONFIG (1<<REFS1)|(1<<REFS0) //internal VREF

// PORTD konfiguracja dla SPI w pliku my_spi.c



// nadzr nad bateri

#define safe_batt

// Declare your global variables here

//flagi

bit timer1_ctc, timer2_ctc, int0_in, int1_in, miara; 

char tekst[]="Wind speed meter",wynik[]="0000";

char tab_konwersji[4];

char timer0_counts, max_w, poz_x, power_off, click, ctc_counts;

int temp, sec;

long avg_w;



// External Interrupt 0 service routine

interrupt [EXT_INT0] void ext_int0_isr(void)

{

// Place your code here

     int0_in=1;

}



// External Interrupt 1 service routine

interrupt [EXT_INT1] void ext_int1_isr(void)

{

// Place your code here

     int1_in=1;

}



// Timer 1 output compare A interrupt service routine

interrupt [TIM1_COMPA] void timer1_compa_isr(void)

{

// odliczaj dokadnie 1 sek. przy kwarcu 4MHz 

    // OCR1A=62500;

     timer1_ctc=1;

// odliczaj dokadnie 0,15 sek. przy kwarcu 4MHz

//     OCR1A=9375;

//     timer1_ctc=1; 

}



// Timer 2 output compare interrupt service routine

interrupt [TIM2_COMP] void timer2_comp_isr(void)

{

// Place your code here

     ctc_counts++;

// przy kwarcu 4MHz i presk.1024 -> 1sek = 16*245 imp. T2     

     if(ctc_counts>8)

     {

          ctc_counts=0;

          timer2_ctc=1;

     }

}



// Read the 8 most significant bits

// of the AD conversion result

unsigned int read_adc(unsigned char adc_input)

{

    ADMUX=ADC_CONFIG|adc_input;

    // Delay needed for the stabilization of the ADC input voltage

    delay_us(10);

    ADCSRA|=(1<<ADSC);               // Start the AD conversion

    while (ADCSRA & (1<<ADSC));      // Wait for the AD conversion to complete

    

    return ADCW;

}

//przeliczanie z liczby segmenty dziesitne

void konwersja(int wartosc)

{

     //uzupea tablice tysiczkami,setkami,dziesitkami, jednostaki; od razu konwersja do ASCII

     tab_konwersji[3]=(wartosc%10000/1000)+0x30;

     tab_konwersji[2]=(wartosc%1000/100)+0x30;

     tab_konwersji[1]=(wartosc%100/10)+0x30;

     tab_konwersji[0]=(wartosc%10)+0x30;

}



void main(void)

{

// Declare your local variables here





// Input/Output Ports initialization

// Port B initialization

// Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=In Func0=In 

// State7=P State6=P State5=1 State4=P State3=1 State2=1 State1=P State0=P 

PORTB=0xFF;

DDRB=0x2C;



// Port C initialization

// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 

// State6=P State5=T State4=T State3=T State2=T State1=T State0=T 

PORTC=0x40;

DDRC=0x00;



// Port D initialization

// Func7=Out Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 

// State7=1 State6=P State5=P State4=P State3=P State2=P State1=P State0=P 

PORTD=0x7F;

DDRD=0x80;



// Timer/Counter 0 initialization

// Clock source: T0 pin Falling Edge

//TCCR0=(1<<CS02)|(1<<CS01);

TCNT0=0x00;



// Timer/Counter 1 initialization

// Clock source: System Clock

// Clock value: 62,500 kHz

// Mode: CTC top=OCR1A

// OC1A output: Discon.

// OC1B output: Discon.

// Noise Canceler: Off

// Input Capture on Falling Edge

// Timer 1 Overflow Interrupt: Off

// Input Capture Interrupt: Off

// Compare A Match Interrupt: On

// Compare B Match Interrupt: Off

TCCR1A=0x00;

//tryb CTC, clk=62,5kHz

//TCCR1B=(1<<WGM12)|(1<<CS11)|(1<<CS10);

TCNT1=0;

ICR1H=0x00;

ICR1L=0x00;

OCR1A=62500;

OCR1BH=0x00;

OCR1BL=0x00;



// Timer/Counter 2 initialization

// Clock source: System Clock

// Clock value: Timer 2 Stopped

// Mode: Normal top=FFh

// OC2 output: Disconnected

ASSR=0x00;

TCCR2=(1<<WGM21)|(1<<CS22)|(1<<CS21)|(1<<CS20);

TCNT2=0x00;

OCR2=244;



// External Interrupt(s) initialization

// INT0: On

// INT0 Mode:Rising

// INT1: On

// INT1 Mode: Failing

GICR|=(1<<INT1)|(1<<INT0);

MCUCR|=(1<<ISC11)|(1<<ISC01)|(1<<ISC00);

// wyczysc zasze przerwania

GIFR=(1<<INT1)|(1<<INT0);



// Timer(s)/Counter(s) Interrupt(s) initialization

TIMSK=(1<<OCIE1A)|(1<<OCIE2);



// Analog Comparator initialization

// Analog Comparator: Off

// Analog Comparator Input Capture by Timer/Counter 1: Off

ACSR=0x80;

SFIOR=0x00;



// ADC initialization

// ADC Clock frequency: 62,500 kHz

// ADC Voltage Reference: AVCC pin

// Only the 8 most significant bits of

// ustaw vref i wszystkie kanay na GND

ADMUX=ADC_CONFIG & 0x0f;

ADCSRA=(1<<ADEN)|(1<<ADPS2)|(1<<ADPS1);



//inicjowanie interfejsw

spi_init();

oled_init();



     oled_string_med(0,0,tekst);

     oled_picture(0,2,Pic1);

     delay_ms(2000);

     //oled_clear();

// Clock source: T0 pin Falling Edge

TCCR0=(1<<CS02)|(1<<CS01);

//tryb CTC, clk=62,5kHz

TCCR1B=(1<<WGM12)|(1<<CS11)|(1<<CS10);

// Global enable interrupts

#asm("sei")



while (1)

      {

          //zwolnienie klawisza S1

          if(int0_in)

          {

               int0_in=0;

               power_off=0;

               click++;

               ctc_counts=0; 

          }



          if(timer1_ctc)

          {

               timer1_ctc=0;

               timer0_counts=TCNT0;

               TCNT0=0;

               if(PIND.2==0) {power_off++;}

          

               sec++;

               //wind

               if(timer0_counts>max_w) {max_w=timer0_counts;}

               avg_w+=timer0_counts;

               //now

               if(miara){konwersja(timer0_counts*6.6);}

               else{konwersja(timer0_counts*24);}

               wynik[0]=tab_konwersji[2];

               wynik[1]=tab_konwersji[1];

               wynik[2]='.';

               wynik[3]=tab_konwersji[0];

               oled_string_big(10,4,wynik);

               //average 10 minutes

               if(miara){konwersja((avg_w*6.6)/sec);}

               else{konwersja((avg_w*24)/sec);}

               wynik[0]=tab_konwersji[2];

               wynik[1]=tab_konwersji[1];

               wynik[2]='.';

               wynik[3]=tab_konwersji[0];

               poz_x=oled_string_med(10,2,wynik);

               strcpyf(tekst," av ");

               oled_string_med(poz_x,2,tekst);

               //rednia 10-cio minutowa

               if(sec>600) 

               {

                    sec=0;

                    avg_w=0;     

               }

               //maximal

               if(miara){konwersja(max_w*6.6);}

               else{konwersja(max_w*24);}

               wynik[0]=tab_konwersji[2];

               wynik[1]=tab_konwersji[1];

               wynik[2]='.';

               wynik[3]=tab_konwersji[0];

               poz_x=oled_string_med(72,2,wynik);

               strcpyf(tekst," mx ");

               oled_string_med(poz_x,2,tekst);

               

               //temperature

               temp=read_adc(0);

               //LM61 0C=0,6V

               if(temp>240)

               {

                    temp-=240;

                    wynik[0]='+';

               }

               else

               {

                    temp=240-temp;

                    wynik[0]='-';

               }

               konwersja(temp/4);

               if(tab_konwersji[1]!='0') {wynik[1]=tab_konwersji[1];}

               else {wynik[1]=' ';}

               wynik[2]=tab_konwersji[0];

               wynik[3]=0x00;

               poz_x=oled_string_med(0,0,wynik);

               //nie pobieraj nowej poz_x, bo jeszcze czyszczenie wiersz niej

               oled_char(poz_x,0,'o');

               poz_x=oled_char(poz_x,1,' ');

               wynik[0]='C';

               wynik[1]=' ';

               wynik[2]=0x00;

               oled_string_med(poz_x,0,wynik);

                              

               //sprawdz stan baterii

               if(PIND.3==0)

               {

                    strcpyf(tekst,"lo_bat!");

                    oled_string_med(80,0,tekst);

                    #ifndef safe_batt

                    {

                         power_off++;

                    }

                    #endif

               }

               

          }

          //Timer2 odliczajcy 0,5sek.

          if(timer2_ctc)

          {

               timer2_ctc=0;

               if(click>1)

               {

                    // czyszczenie wartoci AV i MX przy double click

                    max_w=0;

                    avg_w=0;

                    sec=0; 

               }

               else if (click>0)

               {

                    // zmiania jednostek bez czyszczenia wartoci AV i MX 

                    miara=!miara;

                    oled_clear();

                    if(miara){strcpyf(tekst,"m/s");}

                    else{strcpyf(tekst,"km/h");} 

                    oled_string_med(95,6,tekst);

               }

               click=0;

          }

          //jesli zmienna "power_off" zwikszana co 1sek. przyjmie co najmnie 2 znaczy wycz si

          if(power_off>1)

          {

               oled_clear();

               //podnie lini /ON LP2951 i czekaj na zwolnienie S1

               PORTD.7=1;

               while(1);

          }  

      };

}



